// Mp3.h: CMp3 NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MP3_H__1F1D23AE_87DA_11D3_8D95_8F8CAB181439__INCLUDED_)
#define AFX_MP3_H__1F1D23AE_87DA_11D3_8D95_8F8CAB181439__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// VBMP3.DLL p *.mp1, *.mp2, *.mp3, *.rmp, *.wav ̍ĐȂǂsNXB

#define INFO_NAME_SIZE		128

struct InputInfo
{
	char	szTrackName[INFO_NAME_SIZE];	//Ȗ
	char	szArtistName[INFO_NAME_SIZE];	//A[eBXg
	int		channels;
	int		bitRate;		//rbg[g
	int		samplingRate;	//TvO[g
	int		totalSec;		//t
};

struct TAG_INFO
{
	char	szTrackName[INFO_NAME_SIZE];	//Ȗ
	char	szArtistName[INFO_NAME_SIZE];	//A[eBXg
	char    szAlbumName[INFO_NAME_SIZE];	//Ao
	char	szYear[5];						//[XN
	char	szComment[INFO_NAME_SIZE];		//Rg
	int		genre;							//W
	char    szGanreName[INFO_NAME_SIZE];	//W
};

struct MPEG_INFO
{
	int		version;		//MPEG̃o[W
	int		layer;			//MPEG̃C
	int		crcDisable;		//G[ی
	int		extension;		//l
	int		mode;			//`l[h
	int		copyright;		//쌠
	int		original;		//IWi
	int		emphasis;		//GtHVX		

	int		channels;		//o̓`l
	int		bitRate;		//rbg[g
	int		samplingRate;	//TvO[g
	int		fileSize;		//t@CTCY
	int		flames;			//t[
	int		totalSec;		//t
};

typedef int (APIENTRY * VERSION)(void);
typedef BOOL (APIENTRY * BOOL_VOID)(void);
typedef BOOL (APIENTRY * TAG)(TAG_INFO*);
typedef BOOL (APIENTRY * MPEG)(MPEG_INFO*);
typedef BOOL (APIENTRY * OPEN)(const char*,InputInfo*);
typedef int (APIENTRY * STATE)(int*);
typedef BOOL (APIENTRY * SEEK)(int);
typedef BOOL (APIENTRY * VOL)(int,int);

class CMp3  
{
public:
	CMp3();			// ckkAS֐[h
	virtual ~CMp3();// 

	bool IsAble(){return (m_hDLL!=NULL);};	// gp\IH
	int GetVersion();	// ckk̃o[WԍPOO( error-1Ԃ )

	bool Open( const char* pFileName );	// t@CJ

	bool Play();	// Đ
	bool Stop();	// ~
	bool Restart();	// ꎞ~畜A
	bool Pause();	// ꎞ~

	int GetState(int* sec);	// ԒĺA|PFG[@OF~@PFĐ@QFꎞ~
							// ͕bAhX
	bool SeekTo( int sec );	// |WVړ
	bool SetVolume( int r, int l );	// Ẽ{[

	InputInfo & Info(){return m_InputInfo;};// ͏擾
	TAG_INFO & Tag(){return m_TagInfo;};	// ^O擾
	MPEG_INFO & Mpeg(){return m_MpegInfo;};	// MPEG擾

protected:
	HMODULE m_hDLL;

	InputInfo m_InputInfo;
	TAG_INFO m_TagInfo;
	MPEG_INFO m_MpegInfo;

	BOOL_VOID F_Init;
	BOOL_VOID F_Free;
	BOOL_VOID F_Close;
	BOOL_VOID F_Stop;
	BOOL_VOID F_Play;
	BOOL_VOID F_Pause;
	BOOL_VOID F_Restart;
	OPEN F_Open;
	STATE F_State;
	SEEK F_Seek;
	VOL F_Vol;
	VERSION F_Ver;
	TAG F_Tag;
	MPEG F_Mpeg;
};

#endif // !defined(AFX_MP3_H__1F1D23AE_87DA_11D3_8D95_8F8CAB181439__INCLUDED_)
